   /* initialize connection to server, get XContext */
xContext    = UNO.connect()  -- connect to server and retrieve the XContext object
XMcf        = xContext~getServiceManager   -- retrieve XMultiComponentFactory

packageName = "ScriptProviderForooRexx.jar"
mediaType   = "application/vnd.sun.star.uno-component;type=Java"

tmpName     = stream(packageName, "C", "QUERY EXISTS")   -- get fully qualified filename
if tmpName  = "" then
do
   .error~say("Cannot find" pp(packageName)", aborting...")
   exit -1
end
urlName     = ConvertToUrl(tmpName) -- turn into ucp compliant URL

   -- get the pre-registered package manager factory singleton object
pmName="/singletons/com.sun.star.deployment.thePackageManagerFactory"
xpmf=xContext~getValueByName(pmName)~XPackageManagerFactory

   -- work on the "user" package context
xpmUser  =xpmf~getPackageManager("user")        -- package manager context
if removePackage(xpmUser, .true,  packageName) then   -- make sure, package is removed
   call removePackage xpmUser, .false, packageName    -- just list
say

   -- work on the "shared" package context
xpmShared=xpmf~getPackageManager("shared")      -- package manager context
if removePackage(xpmShared, .true,  packageName) then -- make sure, package is removed
   call removePackage xpmShared, .false, packageName  -- just list
say

xpmShared~addPackage(urlName, mediaType, .nil, .nil)  -- add package
call removePackage xpmShared, .false, packageName  -- just list


::requires UNO.CLS    -- get UNO support

   -- remove package if already deployed
::routine removePackage
  use arg xpm, bRemove, packageName

  bRemove=(bRemove<>.false)   -- default to .true == remove Package
  tab="09"x
  say "Package manager's context:" pp(xpm~getContext)

  dps=xpm~getDeployedPackages(.nil, .nil)    -- get array of XPackages
  ret=.false
  if dps~items=0 then         -- no packages deployed in this context
  do
     say tab "/// No packages found."
     return ret
  end

  i=0
  do dp over dps
     i=i+1
     say tab i"/"dps~items":" "isRegistered:" pp(dp~isRegistered(.nil,.nil)~value~value) "name:" pp(dp~getName)
     if bRemove=.true & dp~getName=packageName then
     do
        say tab tab "--> Found" pp(packageName)", now removing..."
        xpm~removePackage(packageName, .nil, .nil)
        ret=.true
     end
  end
  return ret



