/*
      purpose: test new BSF() subfunction "addEventListenerReturningEventInfos":
      date:    2006-02-24, ---rgf


         /* ********************************************************
         * call BSF 'addEventListenerReturningeEventInfos', beanName, eventSetName, filter, script[, sendBackData]
         *
         * - beanName: the bean that fires the event
         * - eventSetName: the set the event belongs to
         * - filter: the actual event
         * - script: the script to be run, if the event fires
         * - sendBackData: optional data to be sent back for processing
         *********************************************************/
*/



if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."

.bsf~bsf.import("java.awt.Frame" , "awtFrame" )
.bsf~bsf.import("java.awt.Button", "awtButton")
.bsf~bsf.import("java.awt.Label"  ,"awtLabel" )

win=.awtFrame~new("Show Count")
win~bsf.addEventListener('window', 'windowClosing', '.bsf~bsf.exit')

but=.awtButton~new("Press me!")
-- but~bsf.addEventListener('action', '', 'call ShowCount')
but~bsf.addEventListenerReturningEventInfos('action', '', 'call ShowCount')

lab=.awtLabel~new ~~setAlignment(1)

win ~~add("Center", lab) ~~add("South", but)
win ~~pack ~~show ~~toFront

i=0             /* set counter to 0     */

do forever
   a = bsf("pollEventText")     /* wait for an eventText to be sent     */
   obj=bsf.getEventInfoObject(a)
   say "received the following eventText: ["a"]"
   say "obj="pp(obj)
   call dumpy obj
   interpret a                  /* execute as a Rexx program    */
   if result= "SHUTDOWN, REXX !" then leave     /* JVM will be shutdown in 1/10sec      */
end

exit

        /* show the actual number of times, you pressed the button      */
ShowCount:
   i=i+1
   lab~setText("Press #" i)
   return

::requires BSF.CLS    -- get access to the Object Rexx support enhancement

::routine dumpy
  use arg arr
  if .nil=arr then return

-- say "dumpy(): arr=" pp(arr) "of type:" pp(arr~class~string)
-- say "dumpy(): arr~items="pp(arr~items)
-- say "dumpy(): arr~makearray="pp(arr~makearray)

  do item over arr
     say "  item:" pp(item) "type:" pp(item~class)
     -- tmp=bsf.wrap(item)
     -- say "   tmp:" pp(tmp) "type:" pp(tmp~class)
     -- if tmp~class~string="BSF_ARRAY_REFERENCE" then
     -- do item2 over tmp
     --    say "       item2:" pp(item2)
     -- end

     say "item~class~string="pp(item~class~id)
     if item~class~id="BSF_ARRAY_REFERENCE" then
     do item2 over item
        say "       item2:" pp(item2)
     end
  end

  say "--->" "eventObject="pp(arr[1][1]) "type:" pp(arr[1][1]~class)


