/* classic Rexx version, ---rgf, 2003-02, 2003-05-10, 2003-09-04, 2005-12-28 */
/*
   license:

    ------------------------ Apache Version 2.0 license -------------------------
       Copyright (C) 2001-2006 Rony G. Flatscher

       Licensed under the Apache License, Version 2.0 (the "License");
       you may not use this file except in compliance with the License.
       You may obtain a copy of the License at

           http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing, software
       distributed under the License is distributed on an "AS IS" BASIS,
       WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
       See the License for the specific language governing permissions and
       limitations under the License.
    -----------------------------------------------------------------------------
*/
/* this version works on Java 1.1 too (because using "wrapEnumeration()") */

      /* load the BSF4Rexx functions and start a JVM, if necessary */
if rxFuncQuery("BSF") = 1 then   /* BSF() support not loaded yet ? */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs          /* load all BSF*() functions  */
   call BsfLoadJava           /* load Java                  */
end

   /* 'Class.class' is pre-registered for Rexx, cf. docs */
system=bsf('invoke', 'Class.class', 'forName', 'java.lang.System')

properties=bsf('invoke', system, "getProperties")  /* get the System properties  */

enum=bsf('invoke', properties, 'propertyNames')    /* get an enumeration of the property names */

   /* wrap the Enumeration object, so Java 1.1 can handle this too (overcome Java inner class access restriction) */
   /* the following statement is *not* necessary for Java >= 1.2 */
enum=bsf('wrapEnumeration', enum)

say copies("=", 70)

stem. = 0
deli  = "010203"x
do i=1 to 5000 while bsf('invoke', enum, 'hasMoreElements') /* loop over enumeration   */
   key=bsf('invoke', enum, 'nextElement')
   stem.i= key || deli || bsf('invoke', properties, 'getProperty', key)
   stem.0=i       /* remember total of elements */
   -- .error~say("stem."i "=" '"'stem.i~c2x'"x')
end
-- .error~say("stem.0="stem.0)

say stem.0 "elements, now sorting..."
call sysStemSort "stem."

l=length(stem.0)
do i=1 to stem.0
   parse var stem.i key (deli) val
   say i~right(l)":" pp(key)~left(31)"="pp(val)
end

exit

pp: procedure
   return "[" || arg(1) || "]"


