signal on syntax name syntax
signal on error name syntax
signal on failure name syntax
signal on halt name syntax

-- ooRexx 3.2.0: if not sleeping, then sometimes the requires is *not* resolved yet!!
-- call sysSleep .001
call bsfShowErrorMessage .true   -- 2009-04-12: show Java error message

use arg threadName, maxSleepTime=2

s1=".uno~items="pp(.uno~items) ".uno~identityHash="pp(.uno~identityHash)
s2=".bsf4rexx~items="pp(.bsf4rexx~items) ".bsf4rexx~identityHash="pp(.bsf4rexx~identityHash)

say "  * Rexx: threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) -
    "Hello from Rexx!" .dateTime~new
    -- s1 s2 -
    -- getInfo()

-- now create a document an insert the infos from this thread into it
oDesktop         = UNO.createDesktop()    -- get the OOo Desktop service object
xComponentLoader = oDesktop~XDesktop~XComponentLoader  -- get componentLoader
                                                       -- interface
/* open the blank *.sxw - file */
url = "private:factory/swriter"
xWriterComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .uno~noProps)

/* create the TextObject */
xText= xWriterComponent~XTextDocument~getText
xText~setString("Hello World, this ooRexx speaking!" .endOfLine || "threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) "Hello from Rexx!" .dateTime~new getInfo())

call time "R"
do while time("E")<maxSleepTime
   sleepTime=random(1,trunc(1000*maxSleepTime/3))/1000  -- make sure we yield at least three times
   sleepTime=format(sleepTime, , 3)
   say "  * Rexx: threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) "Sleeping" pp(sleepTime) "sec(s)..." .dateTime~new -- getInfo()
   call sysSleep sleepTime
end

/* set "modified" false -> UNO will not ask if you want to save the current document on close */
xWriterComponent~XModifiable~setModified(.false)

res="///" pp("threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())) "\\\"
say "  * Rexx/"threadName":" pp("@threadName") "TID:" pp(bsfGetTID())","  "returning:" pp(res) getInfo()

return res

syntax :
   co=condition("O")    -- get condition object, describing the condition/exception
   LF="0a"x             -- the line-feed character
   TAB="        "       -- blanks simulating a tab character

   tmpStr=""            -- set to empty string
   do idx over co~makeArray~sort /* sort the directory indexes and iterate over them */
      val=co[idx]       -- get the associated value from the condition object (a directory)
      tmpStr=tmpStr || (idx || ":")~left(25) pp(val) LF

      if val~hasmethod("items") then   -- a collection? show its content
      do item over val
         tmpStr=tmpStr || tab || tab || pp(item) || LF
      end
   end

   if length(tmpStr)>750 then tmpStr=left(tmpStr,750)"..." -- show only the first 750 chars

   /* Are there any Java error messages/stack traces available, if so, show them */
   if var("BSF_ERROR_MESSAGE") | .local~hasEntry("BSF_ERROR_MESSAGE") then -- a BSF error message ?
   do
      if var("BSF_ERROR_MESSAGE") then errStr=BSF_ERROR_MESSAGE   -- variable from this scope
                                  else errStr=.bsf_error_message  -- value from .local environment

      tmpStr=tmpStr LF LF || "-"~copies(80) LF   -- extend the string
      tmpStr=tmpStr          "*** BSF4Rexx Error Information: ***" LF LF
      if length(errStr)>1000 then
         tmpStr=tmpStr || left(errStr,1000)"..."
      else
         tmpStr=tmpStr || errStr
   end

   say "  * Rexx:" pp(threadName) "///" "="~copies(78)
   say "  * Rexx:" pp(threadName) tmpStr
   say "  * Rexx:" pp(threadName) "\\\" "="~copies(78)




::requires uno.cls
::routine  getInfo
  pref="0a09"x
  w=36

/*
  return  -
         pref ".uno~noProps        ="pp(.uno~noProps     )  -
         pref ".uno~any            ="pp(.uno~any)~left(w) pp(bsf.lookupBean(.uno~any))          -
         pref ".uno~anyConverter   ="pp(.uno~anyConverter)~left(w) pp(bsf.lookupBean(.uno~anyConverter)) -
         pref ".uno~bootStrap      ="pp(.uno~bootStrap)~left(w) pp(bsf.lookupBean(.uno~bootStrap)) -
         pref ".uno~propertyValue  ="pp(.uno~propertyValue)~left(w) pp(bsf.lookupBean(.uno~propertyValue)) -
         pref ".uno~rgfReflectUNO  ="pp(.uno~RgfReflectUNO)~left(w) pp(bsf.lookupBean(.uno~RgfReflectUNO)) -
         pref ".uno~unoRuntime     ="pp(.uno~unoRuntime)~left(w) pp(bsf.lookupBean(.uno~unoRuntime)) -
         pref "bsf('getBsfManager')="pp(bsf('getBsfManager'))
*/

tmpStr=""

tmpStr=        pref ".uno~noProps        ="pp(.uno~noProps     )

say ".uno~any:                " pp(.uno~any)
say "bsf.lookupBean(.uno~any):" pp(bsf.lookupBean(.uno~any))

tmpStr=tmpStr  pref ".uno~any                    ="pp(.uno~any)~left(w) -- pp(bsf.lookupBean(.uno~any))
tmpStr=tmpStr  pref ".uno~anyConverter           ="pp(.uno~anyConverter)~left(w) -- pp(bsf.lookupBean(.uno~anyConverter))
tmpStr=tmpStr  pref ".uno~bootStrap              ="pp(.uno~bootStrap)~left(w) -- pp(bsf.lookupBean(.uno~bootStrap))
tmpStr=tmpStr  pref ".uno~propertyValue          ="pp(.uno~propertyValue)~left(w) -- pp(bsf.lookupBean(.uno~propertyValue))
tmpStr=tmpStr  pref ".uno~rgfReflectUNO          ="pp(.uno~RgfReflectUNO)~left(w) -- pp(bsf.lookupBean(.uno~RgfReflectUNO))
tmpStr=tmpStr  pref "bsf('getBsfManager')        ="pp(bsf.wrap(bsf('getBsfManager')))
tmpStr=tmpStr  pref ".bsf4rexx~system.class      ="pp(.bsf4rexx~system.class)
tmpStr=tmpStr  pref ".java.lang.system           ="pp(.java.lang.system)
tmpStr=tmpStr  pref ".bsf4rexx~line.separator~c2x="pp(.bsf4rexx~line.separator~c2x)
tmpStr=tmpStr  pref ".uno~line.separator~c2x     ="pp(.uno~line.separator~c2x)
tmpStr=tmpStr  pref ".bsf4rexx~file.separator    ="pp(.bsf4rexx~file.separator)
tmpStr=tmpStr  pref ".uno~file.separator         ="pp(.uno~file.separator)
tmpStr=tmpStr  pref ".bsf4rexx~path.separator    ="pp(.bsf4rexx~path.separator)
tmpStr=tmpStr  pref ".uno~path.separator         ="pp(.uno~path.separator)
tmpStr=tmpStr  pref "box('boolean', .true)       ="pp(box('boolean', .true))

return tmpStr

