// package bsf4rexx.test;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Vector;

// import org.apache.bsf.BSFEngine;
import org.rexxla.bsf.engines.rexx.RexxEngine;
import org.apache.bsf.BSFException;
import org.apache.bsf.BSFManager;
import org.apache.bsf.util.IOUtils;

public class Test {

	static BSFManager bm = null;
        static RexxEngine re  = null;

        static {
            bm = new BSFManager();
            try {
                // get this BSFManager's Rexx engine
                re=(RexxEngine) bm.loadScriptingEngine("rexx");
            }
            catch (Exception e)
            {}
        }


	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {

            // 1st test run
            System.out.println("1) new Test().run() ...");
            new Test().run();

            System.out.print("... terminating Rexx instances via BSFManager...");
            bm.terminate();
            System.out.println(" returned from terminate().\n---\n");

            // 2nd test run
            System.out.println("2) new Test().run() ...");
            new Test().run();

            System.out.print("... terminating Rexx instances via Rexx Engine...");
            try {
             	re.terminate();  // rgf, 2009-09-10: will throw an exception in 4.0.0 as apply() is used and not the cached 're'
            } catch (Exception e)
	    {
		    System.err.print("\n\tExpected error occurred while 're.terminate()': ["+e+"]");
	    }
            System.out.println(".\n---\n");

/* rgf, 2009-09-10: new BSF4Rexx 4.0.0 does not have this experimental method
            // 3rd test run
            System.out.println("3) new Test().run() ...");
            new Test().run();

            System.out.print("... terminating *ALL* Rexx instances via Rexx Engine...");
            re.terminateAllRexxThreads();
            System.out.println(" returned from terminateAllRexxThreads().\n---\n");

*/
	}

	private void run() throws Exception {
		String ret = exec("script1.rexx");
		System.out.println("... Test.Java-Result=" + ret);

	}

	public String exec(String script) throws BSFException, FileNotFoundException, IOException {
		System.out.println("... Test.Java-Exec START: " + script);

		script = IOUtils.getStringFromReader(new FileReader(script));
		bm.registerBean("test", new TestBean(this));
		String ret = (String)bm.apply("rexx", this.toString(), -1, -1, script, null, new Vector());

		System.out.println("... Test.Java-Exec END");
		return ret;
	}

}
