/* ---rgf, 2009-04-04, purpose: demo and test halting threads, needs
                                the 2009-04-04 version of BSF4Rexx
*/
call bsf.cls         -- load the external Rexx function package BSF and set-up ooRexx support

tid=bsfGetTID()      -- get this thread id

say "main(): TID="tid
arr=.array~new       -- array to receive the thread's id's
maxNr=5

do i=1 to maxNr      -- create maxNr threads
   t=.test~new       -- create a new test object
   say "main(): created object" pp(t)", now RUNning it..."
   t~run(arr)        -- the "run" method will run multithreaded
   call sysSleep .1  -- let's sleep a little bit
end

do while arr~items<>maxNr  -- in case not all threads reported their id yet
   call sysSleep .1
end

say "main(): all" maxNr "threads are running:"  -- list the ids of the running threads
do i=1 to maxNr
   say "   " i":" pp(arr[i])
end
say "---"
call sysSleep .5

signal on halt
say "/// Killing 1st thread (tid="arr[1]") via 'haltThread'..."
call bsf "haltThread", arr[1] -- use the BSF()-subfunction directly
say "\\\ ---"
call sysSleep .5

say "/// Killing 3rd thread (tid="arr[3]") via 'haltThread'..."
call bsf.haltThread arr[3]    -- use the public routine defined in BSF.CLS
say "\\\ ---"
call sysSleep .5

say "/// Killing all threads via RexxEngine's terminateAllRexxThreads()..."
call bsf 'haltThread', 0      -- a tid of "0" causes all ooRexx threads to be halted
say "\\\ ---"
call sysSleep .5

say "main(): Finished."
exit


halt:
  say "-->" "main(): received HALT, exiting, my tid="pp(tid)
  exit -1



::class test         -- define the class
::method init        -- constructor
  expose name
  name=self"@".dateTime~new~string

::attribute name

::method run         -- will run multithreaded
  expose name
  use arg arr

  reply              -- this will cause the remainder to execute on its own thread

  tid=bsfGetTID()    -- get TID of this new thread
  arr~append(tid)    -- enqueue TID (report TID back to caller)

  signal on halt
  do i=1
     say "..." name": round #" i "tid="pp(tid)
     call sysSleep .25
  end

halt:
  say "-->" name": received HALT, exiting from method, thread, my tid="pp(tid)
  exit


::routine pp
  parse arg v
  return "["v"]"
