/* ---rgf, 2009-04-04

   testscript1:

      - create multiple threads, let them report their thread id
      - arbitrarily pick a thread and terminate it via
         a) new BSF-subfunction "haltThread"
         b) BSFManager.terminate()
         c) RexxEngine.terminate()
         d) RexxEngine.terminateAllRexxThreads()
*/
call bsf.cls

call tus

halt:
  say "-->" "main(): received HALT, exiting, my tid="pp(tid)
  exit -1



::routine tus
   tid=bsfGetTID()

   say "tus(): TID="tid
   arr=.array~new
   maxNr=8

   do i=1 to maxNr      -- create maxNr threads
      t=.test~new
      say "tus(): created object" pp(t)", now RUNning it..."
      t~run(arr)
      call sysSleep .1
   end

   do while arr~items<>maxNr
      call sysSleep .1
   end
   say "tus(): all" maxNr "threads are running:"
   do i=1 to maxNr
      say "   " i":" pp(arr[i])
   end
   say "---"
   call sysSleep .5

--   signal on halt
   say "/// Killing 1st thread (tid="arr[1]") via 'haltThread'..."
   say "haltThread:" bsf.wrap(bsf( "haltThread", arr[1]))
   say "\\\ ---"
   call sysSleep .5

   say "/// Killing 5th thread (tid="arr[5]") via 'haltThread'..."
   -- call bsf "haltThread", arr[5]
   say "haltThread:" bsf.wrap(bsf( "haltThread", arr[5]))
   say "\\\ ---"
   call sysSleep .5



   bm=bsf.wrap(bsf('getBSFManager'))   -- get BSFManager
   say "/// Retrieved BSFManager="pp(bm) "\\\"

   re=bm~loadScriptingEngine("rexx")   -- get RexxEngine
   say "/// Retrieved RexxEngine="pp(re)  "\\\"
   say "\\\ ---"


   say "/// Killing 7th thread (tid="arr[7]") via RexxEngine.terminate("arr[7]")..."
   -- say "re~terminate("arr[7]"):" re~terminate(arr[7])
   say "re~terminate("arr[7]"):" re~halt(arr[7])   -- as of BSF4Rexx 4.0
   say "\\\ ---"
   call sysSleep .5


   /*
       // Killing the main thread would only kill the main thread (not trappable),
       // but all other threads would continue to run

   say "/// Killing main thread (tid="tid") via BSFManager's terminate()..."
   signal on halt
   bm~terminate
   say "\\\ ---"
   call sysSleep .5

   say "/// Killing main thread (tid="tid") via RexxEngine's terminate()..."
   signal on halt
   re~terminate
   say "\\\ ---"
   call sysSleep .5
   */

   -- say "/// Killing all threads via RexxEngine's terminateAllRexxThreads()..."
   say "/// Killing all threads via RexxEngine's halt(), then terminating Rexx instance using terminate()..."
   signal on halt
   -- re~terminateAllRexxThreads -- alternatively: "call bsf 'haltThread', 0"

   say "\\\ re~halt"
   re~halt                 -- as of BSF4Rexx 4.0
   call sysSleep .5
   say "\\\ ---"

   say "\\\ re~terminate"
   re~terminate            -- as of BSF4Rexx 4.0
   say "\\\ ---"
   call sysSleep .5


   say "tus(): Finished."
   exit

   halt:
     say "-->" "tus(): received HALT, exiting, my tid="pp(tid)
     raise propagate
     exit -1




::class test
::method init
  expose name
  name=self"@".dateTime~new~string

::attribute name

::method run
  expose name
  use arg arr

  reply
  tid=bsfGetTID()    -- get TID
  arr~append(tid)    -- enqueue TID

  signal on halt
  do i=1
     say "..." name": round #" i "tid="pp(tid)
     call sysSleep .25
  end

halt:
  say "-->" name": received HALT, exiting from method, thread, my tid="pp(tid)
  exit


::routine pp
  parse arg v
  return "["v"]"
