/* ---rgf, 2009-04-04

   testscript1:

      - create multiple threads, let them report their thread id
      - arbitrarily pick a thread and terminate it via
         a) new BSF-subfunction "haltThread"
         b) BSFManager.terminate()
         c) RexxEngine.terminate()
         d) RexxEngine.terminateAllRexxThreads()
*/
call bsf.cls

tid=bsfGetTID()

say "main(): TID="tid
arr=.array~new
maxNr=8

do i=1 to maxNr      -- create maxNr threads
   t=.test~new
   say "main(): created object" pp(t)", now RUNning it..."
   t~run(arr)
   call sysSleep .1
end

do while arr~items<>maxNr
   call sysSleep .1
end
say "main(): all" maxNr "threads are running:"
do i=1 to maxNr
   say "   " i":" pp(arr[i])
end
say "---"
call sysSleep .5

signal on halt
say "/// Killing 1st thread (tid="arr[1]") via 'haltThread'..."
call bsf.haltThread arr[1]    -- use public routine of BSF.CLS
say "\\\ ---"
call sysSleep .5

say "/// Killing 5th thread (tid="arr[5]") via 'haltThread'..."
.bsf~bsf.haltThread( arr[5] ) -- use class method of .BSF
say "\\\ ---"
call sysSleep .5



bm=bsf.wrap(bsf('getBSFManager'))   -- get BSFManager
say "/// Retrieved BSFManager="pp(bm) "\\\"

re=bm~loadScriptingEngine("rexx")   -- get RexxEngine
say "/// Retrieved RexxEngine="pp(re)  "\\\"
say "\\\ ---"

say "/// Killing 7th thread (tid="arr[7]") via RexxEngine.terminate("arr[7]")..."
re~terminate(arr[7])
say "\\\ ---"
call sysSleep .5


/*
    // Killing the main thread would only kill the main thread (not trappable),
    // but all other threads would continue to run

say "/// Killing main thread (tid="tid") via BSFManager's terminate()..."
signal on halt
bm~terminate
say "\\\ ---"
call sysSleep .5

say "/// Killing main thread (tid="tid") via RexxEngine's terminate()..."
signal on halt
re~terminate
say "\\\ ---"
call sysSleep .5
*/

say "/// Killing all threads via RexxEngine's terminateAllRexxThreads()..."
signal on halt
-- re~terminateAllRexxThreads -- alternatively: "call bsf 'haltThread', 0"
-- .bsf~bsf.haltThread(0)  -- terminate all Rexx threads
call bsf.haltThread 0      -- terminate all Rexx threads
say "\\\ ---"
call sysSleep .5


say "main(): Finished."
exit


halt:
  say "-->" "main(): received HALT, exiting, my tid="pp(tid)
  exit -1




::class test
::method init
  expose name
  name=self"@".dateTime~new~string

::attribute name

::method run
  expose name
  use arg arr

  reply
  tid=bsfGetTID()    -- get TID
  arr~append(tid)    -- enqueue TID

  signal on halt
  do i=1
     say "..." name": round #" i "tid="pp(tid)
     call sysSleep .25
  end

halt:
  say "-->" name": received HALT, exiting from method, thread, my tid="pp(tid)
  exit


::routine pp
  parse arg v
  return "["v"]"
