/* ---rgf, 2001-06-04, test Object Rexx threads pumping eventTexts asynchroneously ... */
/*
if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end
*/

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."


tid=BsfGetTID() -- rgf, 2008-07-27, get TID

Say "Playing 'counting to three' ..." "tid="pp(tid)
endToken="finish!"
.eventPump~new("German",  .array~of("eins", "zwei", "drei",  endToken), 0 )
.eventPump~new("Italia",  .array~of("uno",  "due",  "tre",   ),  1 )
.eventPump~new("English", .array~of("one",  "two",  "three"  ),  2 )
.eventPump~new("France",  .array~of("un",   "deux", "trois"  ),  1 )
.eventPump~new("Spanish", .array~of("un",   "dos",  "tres"   ),  2 )

sleep=5
say "===     sleeping" sleep "secs before starting to dispatch..." "tid="pp(tid)
call syssleep sleep
tab="09"x
say "="~copies(80)
say "===     " pp(time('L')) "- starting to dispatch event texts ..." "tid="pp(tid)
do forever
   -- txt = bsf("pollEventText", 100)
   txt=.bsf~bsf.pollEventText(100)
   say "=== Orx, pollEventText():" pp(txt)~left(50,".")  "tid="pp(tid)
   if word(txt,1)=endToken then leave
end
say "=== " pp(time('L')) "- received endToken" pp(endToken)", stopped." "tid="pp(tid)


::requires BSF.CLS -- get Object Rexx support for BSF4Rexx

::routine pp
  return "[" || arg(1)~string || "]"

-- class to asynchroneously and intermittently pump eventTexts ..
::class eventPump
::method init
  use arg lang, eventText, level
  level=min(max(0,level), 2)    -- make sure level is 0, 1, 2

  -- call bsf 'sleep', '1.0'
  call SysSleep .50
  .bsf~bsf.PostEventText( pp(lang) "#1/L1: before REPLY-statement!"       )
  .bsf~bsf.PostEventText( pp(lang) "#2/L0: before REPLY-statement! /0/",  0 )
  .bsf~bsf.PostEventText( pp(lang) "#3/L2: before REPLY-statement! /2/",  2 )
  tid=BsfGetTID() -- rgf, 2008-07-27, get TID
  say "--- ---> now reply'ing, tid="pp(tid) "before [reply] ..."
  reply  -- 2003-01-23, ---rgf, does not work, BSF() must not be called from

  tid2=BsfGetTID() -- rgf, 2008-07-27, get TID
  -- now we are executing on a new thread, attach to Java
  say ">>> >>>  after 'reply', BsfAttachToTID("tid"):" BsfAttachToTID(tid) pp(lang) "--> ---> ---> this TID="pp(tid2)

         --                     different Object Rexx threads!
         -- rgf, now works (2003-07-25)
  say '>>>      tid2='pp(tid2)': pumping' pp(lang) 'at level' pp(level) '...'

        -- now give randomizer a seed to make sure sleeping times are independent
  numeric digits 20
  tmp=random(tid2//10000)       -- seed
  do item over eventText
     sleepTime = random(50,500)/1000
     say ">>>      \\\ sleeping" sleepTime "seconds /// (on the Java side)" || ", tid2="pp(tid2)", lang="pp(lang)
     call bsf 'sleep', sleepTime
     .bsf~bsf.postEventText(item, level)   -- add eventText to level
  end
  say "<<< <<<  BSFDetach():" BSFDetach()", tid2="pp(tid2)", lang="pp(lang)
  say (" after BSFDetach() in tid2="pp(tid2)", lang="pp(lang)" ")~center(80, "-")

