#!/usr/bin/rexx
-- 2008-09-09, rgf:

-- this will autoresolve interfaces as well
-- will stop only at the intentional error, where a value cannot be coerced to the target type


call uno.cls

-- .uno~xPropertySetAutoCase=.false -- if prop name not found pick a matching case, if possible
-- .uno~xPropertySetAutoBox =.false  -- autobox property values with "setPropertyValue"

.uno~bAutoResolveQueryInterface=.true  -- carry out query interface...

-- say "BsfShowErrorMessage was set to:" BsfShowErrorMessage(.true)", now set to .true."

context=uno.connect()
sm=context~getServiceManager
msf=sm~XMultiServiceFactory
mcf=sm~XMultiComponentFactory
say "sm: " pp(sm~tostring)
say "msf:" pp(msf~tostring)
say "mcf:" pp(mcf~tostring)
say "---"

service="com.sun.star.sdb.QueryDefinition"
say "service" pp(service) "with properties!"
tmp=msf~createInstance(service)
say "tmp=                      "pp(tmp)
say "tmp~toString=             "pp(tmp~toString)
say "tmp~uno.getServiceNames=  "ppd(tmp~uno.getServiceNames)
say "tmp~uno.getInterfaceNames="ppd(tmp~uno.getInterfaceNames)
say "tmp~uno.getDefinition=    "ppd(tmp~uno.getDefinition)
say "tmp~uno.getProperties=    "ppd(tmp~uno.getProperties)
say "---"
say "trying to set a property, using eventually a wrong datatype:"
say
xps=tmp~XPropertySet
say "xps="pp(xps)
say "---"
say "'FontFamily' (short) -   before:" pp(xps~getPropertyValue("FontFamily"))
xps~setPropertyValue("FontFamily",    box("short", 3))
say "'FontFamily' (short) - after #1:" pp(xps~getPropertyValue("FontFamily"))
xps~setPropertyValue("FONTFAMILY",    box("short", 4))
say "'FontFamily' (short) - after #2a:" pp(xps~getPropertyValue("FontFamily")) "(using exact case)"
say "'FontFamily' (short) - after #2b:" pp(xps~getPropertyValue("FONTFAMILY")) "(using all uppercase)"
say "---"

say "'Command' (string) -   before:" pp(xps~getPropertyValue("Command"))
xps~setPropertyValue("Command",    "This is a SQL-test-Command")
say "'Command' (string) - after #1:" pp(xps~getPropertyValue("Command"))
say "---"

say "'FontCharWidth' (float) -   before:" pp(xps~getPropertyValue("FontCharWidth"))
xps~setPropertyValue("FontCharWidth", box("float", 9.2))
say "'FontCharWidth' (float) - after #1:" pp(xps~getPropertyValue("FontCharWidth"))
say "---"

say "'FontKerning' (boolean) -   before:" pp(xps~getPropertyValue("FontKerning"))
xps~setPropertyValue("FontKerning", box("boolean", .true))
say "'FontKerning' (boolean) - after #1:" pp(xps~getPropertyValue("FontKerning"))
say "---"

say "'RowHeight' is initially 'void', i.e. null/.nil:"
say "'RowHeight' (int) -   before:" pp(xps~getPropertyValue("RowHeight"))
xps~setPropertyValue("RowHeight", box("int", "FF 00 00"x~c2d))
say "'RowHeight' (int) - after #1 (value)   :" pp(xps~getPropertyValue("RowHeight"))

   -- nullifying a MAYBEVOID property works with '.uno~nil' (Any~void) only!
xps~setPropertyValue("RowHeight", .uno~nil)
say "'RowHeight' (int) - after #2 (.uno~nil):" pp(xps~getPropertyValue("RowHeight"))
xps~setPropertyValue("RowHeight", box("int", "00 FF 00"x~c2d))
say "'RowHeight' (int) - after #3 (value)   :" pp(xps~getPropertyValue("RowHeight"))
xps~setPropertyValue("RowHeight", box("int", "00 00 FF"x~c2d))
say "'RowHeight' (int) - after #4 (value)   :" pp(xps~getPropertyValue("RowHeight"))
say "---"
say
say "Testing autoBoxing:"
say
say "'FontFamily' (short) -   before:" pp(xps~getPropertyValue("FontFamily"))
xps~setPropertyValue("FontFamily",    12)
say "'FontFamily' (short) - after #1:" pp(xps~getPropertyValue("FontFamily"))
xps~setPropertyValue("FONTFAMILY",    98)
say "'FontFamily' (short) - after #2a:" pp(xps~getPropertyValue("FontFamily")) "(using exact case)"
say "'FontFamily' (short) - after #2b:" pp(xps~getPropertyValue("FONTFAMILY")) "(using all uppercase)"
say "---"

say "'Command' (string) -   before:" pp(xps~getPropertyValue("Command"))
xps~setPropertyValue("Command",    "This is a SQL-test-Command")
say "'Command' (string) - after #1:" pp(xps~getPropertyValue("Command"))
say "---"

say "'FontCharWidth' (float) -   before:" pp(xps~getPropertyValue("FontCharWidth"))
xps~setPropertyValue("FontCharWidth", 12.3)
say "'FontCharWidth' (float) - after #1:" pp(xps~getPropertyValue("FontCharWidth"))
say "---"

say "'FontKerning' (boolean) -   before:" pp(xps~getPropertyValue("FontKerning"))
xps~setPropertyValue("FontKerning", box("boolean", .true))
say "'FontKerning' (boolean) - after #1:" pp(xps~getPropertyValue("FontKerning"))
say "---"

say "'RowHeight' is initially 'void', i.e. null/.nil:"
say "'RowHeight' (int) -   before:" pp(xps~getPropertyValue("RowHeight"))
xps~setPropertyValue("RowHeight", "F0 0F 0F"x~c2d)
say "'RowHeight' (int) - after #1 (value)   :" pp(xps~getPropertyValue("RowHeight"))

say "'FontHeight' -   before:" pp(xps~getPropertyValue("FontHeight"))
xps~setPropertyValue("FontHeight",    3)
say "'FontHeight' - after #1:" pp(xps~getPropertyValue("FontHeight"))
say "---"


say "'FontKerning' (boolean) -   before:" pp(xps~getPropertyValue("FontKerning"))

xps~setPropertyValue("FontKerning", 0)
say "'FontKerning' (boolean) - after #1 - '0' :" pp(xps~getPropertyValue("FontKerning"))
xps~setPropertyValue("FontKerning", 1)
say "'FontKerning' (boolean) - after #2 - '1' :" pp(xps~getPropertyValue("FontKerning"))

xps~setPropertyValue("FontKerning", .false)
say "'FontKerning' (boolean) - after #3 - '.false' :" pp(xps~getPropertyValue("FontKerning"))
xps~setPropertyValue("FontKerning", .true)
say "'FontKerning' (boolean) - after #4 - '.true' :" pp(xps~getPropertyValue("FontKerning"))

xps~setPropertyValue("FontKerning", "faLse")
say "'FontKerning' (boolean) - after #5 - 'faLse' :" pp(xps~getPropertyValue("FontKerning"))
xps~setPropertyValue("FontKerning", "tRue")
say "'FontKerning' (boolean) - after #6 - '.tRue' :" pp(xps~getPropertyValue("FontKerning"))

say "/// ===>"
.uno~bAutoResolve=.true -- if not behaving like OOo Basic, then show path & propagate the error
tmp~setPropertyValue("FontKerning", "faLSE")
say "'FontKerning' (boolean) - after #7a - no XPropertySet! -> false':" pp(tmp~getPropertyValue("FontKerning"))
tmp~setPropertyValue("FontKerning", "trUE")
say "'FontKerning' (boolean) - after #7b - no XPropertySet! -> true':" pp(tmp~getPropertyValue("FontKerning"))
.uno~bAutoResolve=.false
say "<=== \\\"
say


xps~setPropertyValue("FontKerning", .nil)
say "'FontKerning' (boolean) - after #8 - '.nil':" pp(xps~getPropertyValue("FontKerning"))

xps~setPropertyValue("FontKerning", 99)
say "'FontKerning' (boolean) - after #9 - '99':" pp(xps~getPropertyValue("FontKerning"))
say "---"


say "'FontHeight' -   before:" pp(xps~getPropertyValue("FontHeight"))
xps~setPropertyValue("FontHeight",    "nixi")
say "'FontHeight' - after #1:" pp(xps~getPropertyValue("FontHeight"))


exit


